#!/usr/bin/env python
# GNU GPL

import string
import GameList
import Config
import gettext
import sys,os

import pygtk
pygtk.require('2.0')
import gtk
import gobject

class Setup(gtk.Window):

    query_text="Install"
    query_text_fields={ "rompath":  "Choose directory where the roms are located",
                        "snaps":    "Choose directory or zip file where the snapshots are located",
                        "flyers":   "Choose directory or zip file where the flyers are located",
                        "catver":   "Choose catver.ini file"
         }
    file_selec_titles={ "rompath":  "Select rompath",
                        "snaps":    "Select snapshots",
                        "flyers":   "Select flyers",
                        "catver":   "Select catver.ini file"
         }
    verify_text=    "If the data are correct press Install button to build the GameList"
    #~ verify_text_fields={    "rompath":  "Select rompath",
                            #~ "snaps":    "Select snapshots",
                            #~ "flyers":   "Select flyers",
                            #~ "catver":   "Select catver.ini file"
                        #~ }

    list=["rompath","snaps","flyers","catver"]
    def __init__(self):
        gettext.install('pyxmame','../locale',codeset='ISO-8859-15')

        gtk.Window.__init__(self,gtk.WINDOW_TOPLEVEL)
        self.connect("delete_event", self.delete_event)
        self.connect("key-press-event",self.key_press_event)
        self.set_border_width(10)
        self.set_title("GameList Builder")
        self.set_resizable(False)
        self.set_size_request(600,400)

        self.config=Config.Config()
        self.config.read()
        self.page=list()
        self.page.append(self.create_page_0())
        self.page.append(self.create_page_1())


        win_box=gtk.VBox()
        for page in self.page:
            win_box.pack_start(page,False)
        win_box.pack_start(gtk.HBox(),True)
        win_box.pack_start(self.create_buttons_box(),False)
        
        self.add(win_box)
        self.show_all()
        self.actual_page=0
        for page in self.page:
            page.hide_all()
        self.show_page(None,0)


    def create_page_0(self):
        box=gtk.VBox(False,20)
        self.values= dict()
        for entry in self.list:
            textview=gtk.Label(_(self.query_text_fields[entry]))
            textview.set_alignment(0,1)
        
            self.values[entry]=gtk.Entry()
            self.values[entry].set_max_length(200)
            #self.filter[entry].connect("activate", filter_games)
            self.values[entry].select_region(0, len(self.values[entry].get_text()))
            self.values[entry].connect("insert-text",self.set_text,entry)

            button=gtk.Button(stock=gtk.STOCK_OPEN)
            button.connect("clicked",self.file_selection,entry)

            values_box=gtk.HBox(False,10)
            values_box.pack_start(self.values[entry])
            values_box.pack_start(button,False)

            entry_box=gtk.VBox(False,0)
            entry_box.pack_start(textview)
            entry_box.pack_start(values_box)
            box.pack_start(entry_box)
        return box
        
    def create_page_1(self):
        elems=gtk.VBox(False,10)
        values=gtk.VBox(False,10)
        
        downbox=gtk.HBox(False,20)
        downbox.pack_start(elems,False)
        downbox.pack_start(values)

        box=gtk.VBox(False,10)
        box.pack_start(gtk.Label(self.verify_text))
        box.pack_start(downbox)

        self.labels= dict()
        for entry in self.list:
            label=gtk.Label(_(entry.capitalize())+" :")
            label.set_alignment(0,1)
            elems.pack_start(label)
            
            self.labels[entry]=gtk.Label()
            self.labels[entry].set_alignment(0,1)
            self.values[entry].set_text(self.config[entry])
            values.pack_start(self.labels[entry])
            
        return box

    def create_buttons_box(self):
        self.button=dict()
        
        self.button[gtk.STOCK_CANCEL] = gtk.Button(stock=gtk.STOCK_CANCEL)
        self.button[gtk.STOCK_CANCEL].connect("clicked", self.delete_event, None)

        self.button[gtk.STOCK_GO_BACK] = gtk.Button(stock=gtk.STOCK_GO_BACK)
        self.button[gtk.STOCK_GO_BACK].connect("clicked", self.show_page, -1)

        self.button[gtk.STOCK_GO_FORWARD] = gtk.Button(stock=gtk.STOCK_GO_FORWARD)
        self.button[gtk.STOCK_GO_FORWARD].connect("clicked", self.show_page,1)

        self.button[gtk.STOCK_APPLY] = gtk.Button(stock=gtk.STOCK_APPLY)
        self.button[gtk.STOCK_APPLY].connect("clicked", self.install, None)
        alignment = self.button[gtk.STOCK_APPLY].get_children()[0]
        hbox = alignment.get_children()[0]
        image, label = hbox.get_children()
        label.set_text(_('Install'))

        button_box=gtk.HBox(False, 10)
        button_box.pack_start(self.button[gtk.STOCK_CANCEL],False)
        button_box.pack_start(gtk.HBox(),True)
        button_box.pack_start(self.button[gtk.STOCK_GO_BACK],False)
        button_box.pack_start(self.button[gtk.STOCK_GO_FORWARD],False)
        button_box.pack_start(self.button[gtk.STOCK_APPLY],False)
        return button_box

    def set_text(self,widget,text,text_len,pos,entry):
        if text_len == 1:
            self.labels[entry].set_text(self.values[entry].get_text())
        else:
            self.labels[entry].set_text(text)
        return 

    def file_selection(self,widget,entry):
        selection=gtk.FileSelection(self.file_selec_titles[entry])
        selection.hide_fileop_buttons()
        selection.show_all()
        response = selection.run()
        if response != gtk.RESPONSE_OK:
            selection.destroy()
            return
        self.values[entry].set_text(selection.get_selections()[0])
        selection.destroy()
        return
    
    def show_page(self,widget=None,event=None):
        self.page[self.actual_page].hide_all()
        self.actual_page=self.actual_page+event
        if self.actual_page == 0:
            self.button[gtk.STOCK_GO_BACK].hide_all()
        else:
            self.button[gtk.STOCK_GO_BACK].show_all()
        
        if self.actual_page == (len(self.page) - 1):
            self.button[gtk.STOCK_GO_FORWARD].hide_all()
            self.button[gtk.STOCK_APPLY].show_all()
        else:
            self.button[gtk.STOCK_APPLY].hide_all()
            self.button[gtk.STOCK_GO_FORWARD].show_all()
        
        self.page[self.actual_page].show_all()
        return

    def install(self,widget=None,event=None):
        if not self.valid():
            return
        self.config.read()
        for entry in self.values:
            value=self.values[entry].get_text().strip()
            if value != "":
                self.config[entry]=self.values[entry].get_text()
        self.config.write()
        self.gamelist=GameList.GameList(self.config)
        self.gamelist.build_list()
        gtk.main_quit()
        return

    def valid(self):
        return True

    def delete_event(self, widget, event, data=None):
        dlg = gtk.MessageDialog(type=gtk.MESSAGE_QUESTION)
        dlg.set_markup(_("Exit now ?"))
        dlg.add_button(gtk.STOCK_QUIT,gtk.RESPONSE_OK)
        dlg.add_button(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL)
        response = dlg.run()
        dlg.destroy()
        if response != gtk.RESPONSE_OK:
            return True
        gtk.main_quit()
        return True
       

    def key_press_event(self,event,key):
        key=gtk.gdk.keyval_name(key.keyval)
        if key == "Escape":
            self.delete_event(self, None, None)
            return True
        return

    def main(self):
        gtk.main()
        return

if __name__ == "__main__":
    setup = Setup()
    setup.main()
