#!/usr/bin/env python
# GNU GPL

import pango
import os
import os.path
import pygtk
pygtk.require('2.0')
import gtk
import gobject
import zipfile

class Show(gtk.HBox):
    def __init__(self,config):
        gtk.HBox.__init__(self,False,10)

        self.config=config
        self.set_size_request(-1,200)
        
        self.default_image=config["default_image"]
        self.image=gtk.Image()
        self.image.set_from_file(self.default_image)
        self.image.set_size_request(200,200)

        # snaps
        if zipfile.is_zipfile(config["snaps"]):
           self.snaps=zipfile.ZipFile(config["snaps"],"r")
           self.set_snap_image=self.set_image_from_zipfile
        elif os.path.isdir(config["snaps"]):
           self.snaps=config["snaps"] + "/"
           self.set_snap_image=self.set_image_from_directory
        else:
           self.snaps=None
           self.set_snap_image=self.return_false
        
        # flyers
        if zipfile.is_zipfile(config["flyers"]):
           self.flyers=zipfile.ZipFile(config["flyers"],"r")
           self.set_flyer_image=self.set_image_from_zipfile
        elif os.path.isdir(config["flyers"]):
           self.flyers=config["flyers"] + "/"
           self.set_flyer_image=self.set_image_from_directory
        else:
           self.flyers=None
           self.set_flyer_image=self.return_false
        
        self.titlesBox = gtk.VBox(False, 10)
        self.textView=dict()
        
        attrs=pango.AttrList()
        attrs.insert(pango.AttrSize(20000,0,100))
        #attrs.insert(pango.AttrScale(pango.SCALE_XX_LARGE,0,100))
        self.titlesBox.pack_start(gtk.Label(),True,True,0)
        for entry in config["show"]:
            self.textView[entry]=gtk.Label()
            self.textView[entry].set_attributes(attrs)
            self.textView[entry].set_alignment(1,0)
            self.titlesBox.pack_start(self.textView[entry],False,True,0)
        self.titlesBox.pack_start(gtk.Label(),True,True,0)
        
        self.pack_start(self.titlesBox, True, True, 0)
        self.pack_start(self.image, False, True, 0)
        
        return     

    def set_game(self,game):
        for entry in self.config["show"]:
            self.textView[entry].set_text(game[entry])
        filename = game["rom"] + ".png"
        if not self.set_snap_image(filename,self.snaps) and not self.set_flyer_image(filename,self.flyers):
            self.image.set_from_file(self.default_image)
        return

    def set_image_from_directory(self,filename,directory):
        path=directory + filename
        if not os.access(path,os.R_OK):
            return False
        self.image.set_from_file(path)
        return True
    
    def set_image_from_zipfile(self,filename,zipfile):
        if filename not in zipfile.namelist():
            return False
        data = zipfile.read(filename)
        f = file("/tmp/temp"+str(os.getpid()),"w")
        f.write(data)
        f.close()
        self.image.set_from_file("/tmp/temp"+str(os.getpid()))
        return True
    
    def return_false(self,filename,data):
        return False
